#ifndef SINGLE_SHOOTING_HH
#define SINGLE_SHOOTING_HH

// Single shooting algoithm according to lecture
template <typename M1, typename M2>
class SingleShooting
{
public:
  // Export model
  typedef M1 Model;

  // Export derivative model
  typedef M2 DerivativeModel;

  // Solvers
  typedef hdnum::RungeKutta4<Model> ModelSolver;
  typedef hdnum::RungeKutta4<DerivativeModel> DerivativeModelSolver;

  /** \brief export size_type */
  typedef typename Model::size_type size_type;

  /** \brief export time_type */
  typedef typename Model::time_type time_type;

  /** \brief export number_type */
  typedef typename Model::number_type number_type;


  SingleShooting (Model& model_,
                  DerivativeModel& derivative_model_,
                  number_type u_b_,
                  time_type T_,
                  time_type dt_,
                  bool plot_ = false)
    : model(model_), derivative_model(derivative_model_),
      u_b(u_b_), T(T_), dt(dt_), plot(plot_)
  {}

  // Solve with shooting method and Newton
  void solve(number_type s0=0){
    // TODO
  }


private:

  Model model;
  DerivativeModel derivative_model;

  number_type u_b;
  time_type T;
  time_type dt;

  bool plot;
};

#endif
